/*
 * wireless_power_supply_aux.h
 *
 * common interface, variables, definition etc for wireless power supply
 *
 * Copyright (c) 2020-2020 Huawei Technologies Co., Ltd.
 *
 * This software is licensed under the terms of the GNU General Public
 * License version 2, as published by the Free Software Foundation, and
 * may be copied, distributed, and modified under those terms.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 */

#ifndef _WIRELESS_POWER_SUPPLY_AUX_H_
#define _WIRELESS_POWER_SUPPLY_AUX_H_

#include <chipset_common/hwpower/wireless_charge/wireless_power_supply.h>

struct wlps_aux_dev_info {
	struct device *dev;
	int gpio_tx_sppwr_en_aux;
	int gpio_tx_sppwr_en_valid_val_aux;
	int gpio_txsw_aux;
	int gpio_txsw_valid_val_aux;
	int gpio_rxsw_aux;
	int gpio_rxsw_valid_val_aux;
	int gpio_ext_pwr_sw_aux;
	int gpio_ext_pwr_sw_valid_val_aux;
	int gpio_sc_sw2_aux;
	int gpio_sc_sw2_valid_val_aux;
	int sysfs_en_pwr_aux;
	int proc_otp_pwr_aux;
	int recover_otp_pwr_aux;
};

#ifdef CONFIG_WIRELESS_CHARGER
void wlps_control_aux(enum wlps_ctrl_scene scene, bool ctrl_flag);
#else
static inline void wlps_control_aux(enum wlps_ctrl_scene scene, bool ctrl_flag)
{
}
#endif /* CONFIG_WIRELESS_CHARGER */

#endif /* _WIRELESS_POWER_SUPPLY_AUX_H_ */
