/*
 * Copyright (c) Huawei Technologies Co., Ltd. 2020-2020. All rights reserved.
 * Description: Enum error type.
 * Create: 2020-06-16
 */

#ifndef _HWDPS_ERROR_H
#define _HWDPS_ERROR_H

/* return codes */
typedef enum {
	HWDPS_SUCCESS,
	HWDPS_ERR_INTERNAL = 900001,
	HWDPS_ERR_USER_ALREADY_EXISTS,
	HWDPS_ERR_UNKNOWN_USER,
	HWDPS_ERR_UNATHENTICATED,
	HWDPS_ERR_NO_MEMORY,
	HWDPS_ERR_INVALID_ARGS,
	HWDPS_ERR_INVALID_TOKEN,
	HWDPS_ERR_INVALID_PERMS_RID,
	HWDPS_ERR_INVALID_KEY,
	HWDPS_ERR_REQUEST_TIMEOUT,
	HWDPS_ERR_ACCESS_DENIED,
	HWDPS_ERR_UNKNOWN_PACKAGE,
	HWDPS_ERR_NOT_SUPPORTED,
	HWDPS_ERR_NO_FS_CALLBACKS,
	HWDPS_ERR_PID_NOT_TRUST,
	HWDPS_ERR_UID_NOT_TRUST,
	HWDPS_ERR_NOT_UPDATE_PERM,
	HWDPS_ERR_GET_XATTR,
	HWDPS_ERR_TAG_NOT_MATCH,
	HWDPS_ERR_NOT_OWNER,
	HWDPS_ERR_HKDF_EXTRACT,
	HWDPS_ERR_HKDF_EXPAND,
	HWDPS_ERR_GET_PATH,
	HWDPS_ERR_SET_XATTR,
	HWDPS_ERR_SET_XATTR_EFEK,
	HWDPS_ERR_SET_XATTR_FLAG,
} hwdps_result_t;

#endif
